
# Imprimatur Install Tool

Инсрумент для установки CMS Imprimatur Parser от Студии Лебедева.

В процессе установки происходит проверка доступности источника, и производится
автоматическая установка окружения для разработки проекта на базе CMS Имприматур.

    Для установки CMS Имприматур вы должны находится во внутренней сети студии


## Технологии

### [Node.js](https://nodejs.org/en/)
Node.js® is a JavaScript runtime built on Chrome's V8 JavaScript engine. Node.js uses an event-driven, non-blocking I/O model that makes it lightweight and efficient. Node.js' package ecosystem, npm, is the largest ecosystem of open source libraries in the world.

[Download](https://nodejs.org/en/)

### [Git](https://git-scm.com/) 
Git is a free and open source distributed version control system designed to handle everything from small to very large projects with speed and efficiency.

[Download](https://git-scm.com/downloads)

### [NPM](https://www.npmjs.com/) 
Npm is the package manager for JavaScript. Find, share, and reuse packages of code from hundreds of thousands of developers — and assemble them in powerful new ways.

### [Yarn](https://yarnpkg.com/)
Yarn caches every package it downloads so it never needs to download it again. It also parallelizes operations to maximize resource utilization so install times are faster than ever.

[Install](https://yarnpkg.com/en/docs/install)

### [Imprimatur](http://imprimatur.artlebedev.ru/)
CMS от Студии Лебедева


## Настройка окружения

1) Устанавливаем стабильную версию [Nodejs](https://nodejs.org/en/)

2) Устанавливаем [Yarn](https://yarnpkg.com/en/docs/install). На сайте выбираем вариант для своей операционной системы.
```
    Универсальный:
    npm install --global yarn
```

## Режимы установки
####Глобальный

Позволяет установить инструмент один раз и вызывать в нужной директории 
команду `imprimatur` для установки cms.

```
    npm install -g imprimatur-install-tool
```
В любой директории вызываем установленый инструмент
```
    cd ~/project 
    imprimatur
```

####Локальный

Устнавливает cms в выбранную директорию и не сохраняется в системе
```    
    npm install imprimatur-install-tool
```  

# Создаем новый проект

Перед созданием проекта, у вас есть репозиторий проекта на Github. 
И строка подключения к базе данных текущего проекта 
(найти можно в конфигурационном файле `auto.p` на тестовом серере).

- Клонируем репозитрий на свой компьютер
- В командной строке переходим в директорию проекта
  
      cd ~/project
- Устанавливаем имприматур
      
      npm install imprimatur-install-tool
      

      //если заранее установили инструмент глобально (см. Режимы установки)
      
      imprimatur
- Устанавливаем зависимости проекта. 
      
      npm install
      
      // npm-run-all - позволяет запускать несколько параллельных задач сборки
      // imprimatur-install-tool - позволяет обновить Имприматур
      
- Запускаем сервер разработки
      
      npm start
