const generators = require('yeoman-generator');
const Storage =  require('yeoman-generator/lib/util/storage');
const colors = require('colors');
const extend = require('../../lib/extend.js');

const logoProject = require('../../lib/logo.js');

module.exports = generators.Base.extend({

  constructor: function () {
    generators.Base.apply(this, arguments);

    this.argument('sourcePathArgument', { type: String, required: true });
    this.sourceRoot(this.sourcePathArgument);

    this.argument('destinationPathArgument', { type: String, required: true });
    this.destinationRoot(this.destinationPathArgument);

    // Метод для получения ответов генератора
    this.getAnswers = function (value) {
      if (value && this.answers && this.answers[value]) {
        return this.answers[value];
      }
      return undefined;
    }.bind(this);

    this.localConfig = new Storage('developer', this.fs, this.destinationPath('local.json'));
  },

  prompting: function () {

    logoProject.dev();

    this.answers = this.localConfig.getAll();

    var prompts = [{
      type: 'list',
      name: 'isDeveloper',
      message: 'Включить режим разработки?',
      choices: [
        {name: 'Да', value: "true"},
        {name: 'Нет', value : "false"}
      ]
    }];

    return this.prompt(prompts).then(function (answers) {
      extend(this.answers, answers);
    }.bind(this));
  },

  config: function () {
    var localConfig = new Storage('developer', this.fs, this.templatePath('local.json')).getAll();
    extend(localConfig, this.answers);
    this.localConfig.set(localConfig);
  }

});
