/**
 * (c) 2016 Art. Lebedev Studio
 *
 * @author Iblyaminov Albert <rie@artlebedev.ru>
 */

'use strict';

const colors = require('colors');
const process = require('process');

const Logo = function () {

};

Logo.prototype.print = function () {
  var impLogo = [
    '',
    '@@@@@@@@@@@@@@@@@@@@@+        +@@@@@@@+',
    '      --=@@@@:-             *@@@@@@@@@+',
    '        +@@@@-            -@@@@@=+@@@@+',
    '        +@@@@-           +@@@@*  -@@@@+',
    '        +@@@@-         :@@@+-    -@@@@+',
    '        +@@@@-        -==-       -@@@@+',
    '        +@@@@-                   -@@@@+',
    '        +@@@@-                   -@@@@+',
    '        +@@@@-                   -@@@@+',
    '        +@@@@-                   -@@@@+',
    '        +@@@@-         -         -@@@@+',
    '        +@@@@-      *@@=         -@@@@+',
    '        +@@@@-   -=@@@*          -@@@@+',
    '        +@@@@--+@@@@=            -@@@@+',
    '        +@@@@@@@@@@:             -@@@@+',
    '        +@@@@@@@@+        -:*+=@@@@@@@@@@@+**--',
    '        +@@@@@@=-        +@@@@@@@@@@@@@@@@@@@@@',
    ''
  ];
  this.clearScreen();
  console.log(colors.red(impLogo.join('\n') + '\n\n'));
};

Logo.prototype.parser = function () {
  var parserLogo = [
    '           ``-+osyyhyyss+:.`            ',
    '        .:ydNNNMNNNNNNNNNNNmy+.         ',
    '      -smNNNNNdhyo+++oyhdmNNNNNh/`      ',
    '    -yNNNNNs/.`         `.:odNNNNd/`    ',
    '  `oNNNNm+`                 `-yNNNNy.   ',
    ' `yNNNNo`                      :dNNNd-  ',
    '`sNNNm/          `````          .hNNNd. ',
    ':NNNN+         .-------.`        -hNNNs`',
    'dNNNy`       .-----.-----.`       +NNNN.',
    'NNNNo      .-----.`  `-----.      :dNNN-',
    'NNNNo    .-----.`      `---:-.    :dNNN-',
    'mNNNs` .-----.`          `-----.  +NNNN.',
    '/NNNm/ `---.`              `---.`.yNNNh`',
    '`hNNNd-  ``                  `` `sNNNm- ',
    ' .hNNNm/                       .hNNNN:  ',
    '  .yNNNNy-                   `sNNMNd-   ',
    '   `/dNNMNho-`           `./yNNNNms.    ',
    '     `+hNNNNNmhs+:::::/oydNNNNNms.      ',
    '       `.ohNNNNNNNNNNNMNNNNNdy:`        ',
    '           `-+sydmNNNmdhso:.`           ',
    ''
  ];
  this.clearScreen();
  console.log(colors.green(parserLogo.join('\n') + '\n\n'));
};

Logo.prototype.nodejs = function () {
  const colors = require('colors');
  const process = require('process');
  var nodeLogo = [
    'MMMhyhhhhyhyyyyyyhdmmdhhhhyyyhyyyhhhhMMM',
    'MMM.           -+syyyys+-           .MMM',
    'MMM.       .:oyys+- `-+syyo:.       .MMM',
    'MMM.   `-+syyo:.        .:oyys+-`   .MMM',
    'MMM../oyys/-                -/syyo/..MMM',
    'MMMsyyo:`                      `:oyysMMM',
    'MMMhy+       //-   -/++oo++:.     +yhMMM',
    'MMMhy+       yy+ .syy+///+oyys`   +yhMMM',
    'MMMhy+       yy+ +yy-      .sy+   +yhMMM',
    'MMMhy+       yy+ .syyyso++/:-`    +yhMMM',
    'MMMhy+       yy+   .-:/++osyyy+   +yhMMM',
    'MMMhy+       yy+`ss+        +yy.  +yhMMM',
    'MMMhy+       yy+ /yyo/:--::+yyo   +yhMMM',
    'MMMhy+       yy+  `:+ossssso/.    +yhMMM',
    'MMMoyyo:.   `yy+               .:oyyoMMM',
    'MMM.`:oyyyo+yyy.           `-+syyo:`.MMM',
    'MMM.    -:++/:`         ./oyys/-    .MMM',
    'MMM.         .+yy+:``-+yyyo:`       .MMM',
    'MMM.           ./syyyys/.           .MMM',
    'MMMdhhhhhhhhhhhhhhdNNdhhhhhhhhhhhhhhdMMM'
  ];
  this.clearScreen();
  console.log(colors.green(nodeLogo.join('\n') + '\n\n'));
};

Logo.prototype.mysql = function () {
  var mysqlLogo = [
    '                                   -::-`                    ',
    '                                   :: `:-:::`               ',
    '                                    ./  -` `-/-             ',
    '                                     -:       .+.           ',
    '                                      -:        /:          ',
    '                                      `/         /-         ',
    '                                      -. .        +-        ',
    '                                      .:`o/        /:.`     ',
    '                                       -/-`:`        `-:-   ',
    '                                            ``       .:-::  ',
    '                                                     `:/-   ',
    '  ---      ---             `..-..     ..--.`    ..      `-. ',
    ' `soo-    -oos`           ./:.`..`  ./:.`.-/:`  //`         ',
    ' -s:oo`  `o/+o- :/-   -/- :/-      `/:     -/:  //`         ',
    ' :o.-s+  /o`/o: `oo`  +s` `-:/-.`  -/-     `//  //`         ',
    ' /s. +s-.s- :o/  :o/ .s/     `.:/: -/-     `//  //`         ',
    ' +s` `ooo+  -o+   oo.+o`        //..//`    -/-  //`         ',
    ' os`  :so`  .so   .sos.   ---.-:/-  .:/-.-:/-   //----```.. ',
    ' ..    .`    ..   `oo.      `.``      ``.``-::  ``````   `` ',
    '                /++:`                                       ',
    ''
  ];
  this.clearScreen();
  console.log(colors.magenta(mysqlLogo.join('\n') + '\n\n'));
};

Logo.prototype.dev = function () {
  var devLogo = [
    '                                    ',
    '                                    ',
    '         /oo++:      :++oo/         ',
    '        -oo              oo-        ',
    '        :oo              +o:        ',
    '        :oo              +o:        ',
    '        /o+              +o/        ',
    '    .::+o+.              ./o+::-    ',
    '    .::/o+.              .+o+::.    ',
    '        /o+              +o/        ',
    '        :oo              +o:        ',
    '        :oo              +o:        ',
    '        -oo.            `oo-        ',
    '        `:ooo+/      :+ooo/         ',
    '                                    ',
    '                                    '
  ];
  this.clearScreen();
  console.log(colors.blue(devLogo.join('\n') + '\n\n'));
};

Logo.prototype.cancel = function () {
  this.clearScreen();
  console.log(colors.green('\n------\nInstallation succesfull\n------\n'));
  console.log('Run', colors.yellow('npm start'), 'and load', colors.yellow('localhost:3000'), 'on your browser.');
  console.log('\n\n');
  console.log(colors.yellow('npm run imprimatur'), '\t\t\t- update imprimatur and installed parts');
  console.log(colors.yellow('npm run developer-mode'), '\t\t\t- set Imprimatur to developer mode');
  console.log(colors.yellow('npm run production-mode'), '\t\t- set Imprimatur to production mode');
  console.log(colors.yellow('npm run config'), '\t\t\t\t- set configuration project');
};

Logo.prototype.clearScreen = function () {
  process.stdout.write("\u001b[2J\u001b[0;0H");
};

module.exports = new Logo();
