/**
 * (c) 2016 Art. Lebedev Studio
 *
 * @author Iblyaminov Albert <rie@artlebedev.ru>
 */

const process = require('process');
const path = require('path');
const pathIsAbsolute = require('path-is-absolute');

const Path = function (root) {
  this.args = {};
  this.sourcePath = '';
  this.destinationPath = '';

  this.cwd = process.cwd();

  process.argv.slice(2).forEach(function (val) {
    var tempValue = val.split('=');
    this.setArgs(tempValue[0], tempValue || '');
  }.bind(this));

  this.setDestinationPath(this.cwd);
  this.setSourcePath(path.resolve(__dirname, '..'));
};
Path.prototype.getDestinationPath = function () {
  var filepath = path.join.apply(path, arguments);

  if (!pathIsAbsolute(filepath)) {
    filepath = path.join(this.destinationPath, filepath);
  }
  return filepath;
};
Path.prototype.setDestinationPath = function (value) {
  this.destinationPath = value;
};
Path.prototype.getSourcePath = function () {
  var filepath = path.join.apply(path, arguments);

  if (!pathIsAbsolute(filepath)) {
    filepath = path.join(this.sourcePath, filepath);
  }
  return filepath;
};
Path.prototype.setSourcePath = function (value) {
  this.sourcePath = value;
};
Path.prototype.getArgs = function (name) {
  return this.args[name];
};
Path.prototype.setArgs = function (name, value) {
  this.args[name] = value;
};

module.exports = new Path();
